package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseCheckBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseCheckModelImpl implements ICaseCheckModel {

    private OnGetCaseCheckListener listener;

    public CaseCheckModelImpl(OnGetCaseCheckListener caseCheckListener) {
        this.listener = caseCheckListener;
    }

    public interface OnGetCaseCheckListener {
        void onSuccess(CaseCheckBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(int limit, int offset) {
        Observable<CaseCheckBean> observable = RetrofitServiceManager.getCaseCheckListResult(limit, offset);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseCheckBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseCheckBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
